//------------------------------------------------------------------------------
//
//  npctrl.c
//  npe
//
//  Created by Shane Saxon on 2/19/10.
//  Copyright Saxon Digital 2010. All rights reserved.
//
//------------------------------------------------------------------------------

#include "npdata.h"
#include "npio.h"
#include "npctrl.h"

#include "io/npglut.h"


//------------------------------------------------------------------------------
void npInitCtrl (void* data)
{
}

//------------------------------------------------------------------------------
void npCloseCtrl (void* data)
{
}

//------------------------------------------------------------------------------
int npMainAppLoop (void* data)
{
	int err = 0;

#ifdef _LINUX_
//	MainAppLoopLinux();
#endif

#ifdef _MSW_
//	MainAppLoopMSW();
	npInitGlut (0, 0, data);
	npMainAppLoopGlut (data);
#endif

#ifdef _OSX_
	//	MainAppLoopOSX();
#endif


	return err;
}

//------------------------------------------------------------------------------
void npCtrlCommand (int command)
{
	switch (command)
	{
		case kFullScreenExit : npGlutFullScreenExit(); break;
	}
}

//


//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
/*
#ifdef __APPLE__
#include <GLUT/glut.h>
#include <OpenGL/gl.h>
#else
#include <freeglut.h>
//#include <GL/gl.h>
#endif

#include <stdlib.h>
#include <stdio.h>
#include <math.h>

//#include "io/npgl.h"

#define kWindowWidth 400
#define kWindowHeight 300

struct npColor{
	GLubyte r,g,b,a;
};
typedef struct npColor npColor;
typedef struct npColor * pnpColor;

struct npGrid{
	int segmentX;
	int segmentY;
	int segmentZ;
	int pointSize;
	int lineSize;
	GLfloat sizeX;
	GLfloat sizeY;
	GLfloat sizeZ;
	npColor color;
};
typedef struct npGrid npGrid;
typedef struct npGrid * pnpGrid;

pnpGrid pGrid;

void npGridInit (pnpGrid pGrid);

void npDrawGrid (pnpGrid pGrid);

GLvoid InitGL(GLvoid);
GLvoid DrawGLScene(GLvoid);
GLvoid ReSizeGLScene(int Width, int Height);

void npGridInit (pnpGrid pGrid)
{
	pGrid = (pnpGrid) malloc (sizeof (npGrid));

	pGrid->segmentX = 10;
	pGrid->segmentY = 10;
	pGrid->segmentZ = 0;
	pGrid->pointSize = 0;
	pGrid->lineSize = 1;
	pGrid->sizeX = 10.0;
	pGrid->sizeY = 10.0;
	pGrid->sizeZ = 10.0;
	pGrid->color.r = 255;
	pGrid->color.g = 255;
	pGrid->color.b = 255;
	pGrid->color.a = 255;
}
/*
int main(int argc, char** argv)
{
 glutInit(&argc, argv);
 glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
 glutInitWindowSize (kWindowWidth, kWindowHeight);
 glutInitWindowPosition (100, 100);
 glutCreateWindow ("ANT");

 InitGL();

 glutDisplayFunc(DrawGLScene);
 glutReshapeFunc(ReSizeGLScene);

 glutMainLoop();

 return 0;
}

GLvoid ReSizeGLScene(int width, int height)
{
 if (height==0)
 {
 height=1;
 }

 glViewport(0, 0, width, height);

 glMatrixMode(GL_PROJECTION);
 glLoadIdentity();
 gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,0.1f,100.0f);

 glMatrixMode(GL_MODELVIEW);
 glLoadIdentity();
}

GLvoid InitGL(GLvoid)
{
 glShadeModel(GL_SMOOTH);
 glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
 glClearDepth(1.0f);
 glEnable(GL_DEPTH_TEST);
 glDepthFunc(GL_LEQUAL);
 glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);

 //	glutFullScreen();
//	glutReshapeWindow (100, 100);
//	glutPositionWindow (500, 500);
}

void npDrawGrid (pnpGrid pGrid)
{
	glTranslatef(-1.5f, 0.0f, -6.0f);
	glColor3f(1.0, 0.0, 0.0);

	glBegin(GL_TRIANGLES);
	glVertex3f( 0.0f, 1.0f, 0.0f);
	glVertex3f(-1.0f,-1.0f, 0.0f);
	glVertex3f( 1.0f,-1.0f, 0.0f);
	glEnd();

	glTranslatef(1.0, 1.0, 1.0);
	glColor3f(0.0, 1.0, 0.0);

	glBegin(GL_QUADS);
	glVertex3f(-1.0f, 1.0f, 0.0f);
	glVertex3f( 1.0f, 1.0f, 0.0f);
	glVertex3f( 1.0f,-1.0f, 0.0f);
	glVertex3f(-1.0f,-1.0f, 0.0f);
	glEnd();
}

GLvoid DrawGLScene(GLvoid)
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();

	npDrawGrid( pGrid);

	glutSwapBuffers();
}

/*
#include <freeglut.h>

void
display(void)
{
// clear window
	glClear(GL_COLOR_BUFFER_BIT); 

// draw unit square polygon
	glBegin(GL_POLYGON);
	  glVertex2f(-0.5, -0.5);
	  glVertex2f(-0.5, 0.5);
	  glVertex2f(0.5, 0.5);
	  glVertex2f(0.5, -0.5);
	glEnd();

// flush GL buffers
	glFlush(); 

//	glutFullScreen();
//	glutReshapeWindow (100, 100);
//	glutPositionWindow (500, 500);
}

int
main(int argc, char* argv[])
{
	glutInit(&argc,argv);
	glutCreateWindow("ANT"); 
	glutDisplayFunc(display);
	glutMainLoop();

	return 0;
}
*/

/*
static float angle=0.0,ratio;
static float x=0.0f,y=1.75f,z=5.0f;
static float lx=0.0f,ly=0.0f,lz=-1.0f;
static GLint snowman_display_list;



void changeSize(int w, int h)
	{

	// Prevent a divide by zero, when window is too short
	// (you cant make a window of zero width).
	if(h == 0)
		h = 1;

	ratio = 1.0f * w / h;
	// Reset the coordinate system before modifying
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	
	// Set the viewport to be the entire window
    glViewport(0, 0, w, h);

	// Set the clipping volume
	gluPerspective(45,ratio,1,1000);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(x, y, z, 
		      x + lx,y + ly,z + lz,
			  0.0f,1.0f,0.0f);


	}


void drawSnowMan() {


	glColor3f(0.0f, 1.0f, 1.0f);

// Draw Body	
	glTranslatef(0.0f ,0.75f, 0.0f);
	glutSolidSphere(0.75f,20,20);


// Draw Head
	glTranslatef(0.0f, 1.0f, 0.0f);
	glutSolidSphere(0.25f,20,20);

// Draw Eyes
	glPushMatrix();
	glColor3f(0.0f,0.0f,0.0f);
	glTranslatef(0.05f, 0.10f, 0.18f);
	glutSolidSphere(0.05f,10,10);
	glTranslatef(-0.1f, 0.0f, 0.0f);
	glutSolidSphere(0.05f,10,10);
	glPopMatrix();

// Draw Nose
	glColor3f(1.0f, 0.5f , 0.5f);
	glRotatef(0.0f,1.0f, 0.0f, 0.0f);
	glutSolidCone(0.08f,0.5f,10,2);
}



GLuint createDL() {
	GLuint snowManDL;

	// Create the id for the list
	snowManDL = glGenLists(1);

	// start list
	glNewList(snowManDL,GL_COMPILE);

	// call the function that contains the rendering commands
		drawSnowMan();

	// endList
	glEndList();

	return(snowManDL);
}

void initScene() {

	glEnable(GL_DEPTH_TEST);
	snowman_display_list = createDL();

}





void renderScene(void) 
{
	int i = 0;
	int j = 0;

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

// Draw ground

	glColor3f(0.9f, 0.9f, 0.9f);
	glBegin(GL_QUADS);
		glVertex3f(-100.0f, 0.0f, -100.0f);
		glVertex3f(-100.0f, 0.0f,  100.0f);
		glVertex3f( 100.0f, 0.0f,  100.0f);
		glVertex3f( 100.0f, 0.0f, -100.0f);
	glEnd();

// Draw 36 SnowMen

	for(i = -3; i < 3; i++)
		for(j=-3; j < 3; j++) {
			glPushMatrix();
			glTranslatef(i*10.0,0,j * 10.0);
			glCallList(snowman_display_list);
			glPopMatrix();
		}
	glutSwapBuffers();
}

void orientMe(float ang) {


	lx = sin(ang);
	lz = -cos(ang);
	glLoadIdentity();
	gluLookAt(x, y, z, 
		      x + lx,y + ly,z + lz,
			  0.0f,1.0f,0.0f);
}


void moveMeFlat(int i) {
	x = x + i*(lx)*0.1;
	z = z + i*(lz)*0.1;
	glLoadIdentity();
	gluLookAt(x, y, z, 
		      x + lx,y + ly,z + lz,
			  0.0f,1.0f,0.0f);
}

void ExitFullScreen()
{
//	glutFullScreen();
    glutPositionWindow(50,50);
	glutReshapeWindow(640, 480);        // Restore us
//	glutCreateWindow("ANTZ");
}

void keyDown(unsigned char key, int x, int y) 
{
	switch (key) {
		case 65 : angle -= 0.05f;orientMe(angle);break;
		case 97 : angle -= 0.01f;orientMe(angle);break;
		case 68 : angle +=0.05f;orientMe(angle);break;			
		case 100 : angle +=0.01f;orientMe(angle);break;
		case 87 : moveMeFlat(5);break;
		case 83 : moveMeFlat(-5);break;
		case 27 : ExitFullScreen();break;		//		exit(0);
	}
}

void keyUp(unsigned char key, int x, int y) 
{
}


void keyDownSpecial(int key, int x, int y) {

	switch (key) {
		case GLUT_KEY_LEFT : angle -= 0.05f;orientMe(angle);break;
		case GLUT_KEY_RIGHT : angle +=0.05f;orientMe(angle);break;
		case GLUT_KEY_UP : moveMeFlat(5);break;
		case GLUT_KEY_DOWN : moveMeFlat(-5);break;
		case 65 : angle -= 0.05f;orientMe(angle);break;
		case 97 : angle -= 0.05f;orientMe(angle);break;
		case 68 : angle +=0.05f;orientMe(angle);break;
		case 87 : moveMeFlat(5);break;
		case 83 : moveMeFlat(-5);break;
//		case 27 : ExitFullScreen();break;
	}
}

void keyUpSpecial(int key, int x, int y) 
{
}


int main(int argc, char **argv)
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA);
	glutInitWindowPosition(100,100);
	glutInitWindowSize(640,360);
	glutCreateWindow("ANTZ");
	glutFullScreen();

	initScene();

//	glutIgnoreKeyRepeat(1); //ignore auto-repeat
	glutKeyboardFunc(keyDown);
	glutKeyboardUpFunc(keyUp);
	glutSpecialFunc(keyDownSpecial);
	glutSpecialUpFunc(keyUpSpecial); 

	glutDisplayFunc(renderScene);
	glutIdleFunc(renderScene);

	glutReshapeFunc(changeSize);

	glutMainLoop();

	return(0);
}
*/