//------------------------------------------------------------------------------
//
//  npdata.h
//  npe
//
//  Created by Shane Saxon on 2/19/10.
//  Copyright Saxon Digital 2010. All rights reserved.
//
//------------------------------------------------------------------------------

#ifndef npdata_H_
#define npdata_H_

// #define _LINUX_
#define _MSW_
// #define _OSX_

#define kKeyMapSize 256
#define kKeyEventTypeSize 4

struct Key {
	int		modShift;
	int		modCtrl;
	int		modAlt;
	int		modCommand;
	int		map[kKeyEventTypeSize][kKeyMapSize];
};
typedef struct Key Key;
typedef struct Key * pKey;

struct DataMap {
	int		size;
};
typedef struct DataMap DataMap;
typedef struct DataMap * pDataMap;

struct IO {
	int		size;
	Key		key;
};
typedef struct IO IO;
typedef struct IO * pIO;

struct Ctrl {
	int		size;
};
typedef struct Ctrl Ctrl;
typedef struct Ctrl * pCtrl;

struct Data {
	DataMap dataMap;
	IO		io;
	Ctrl	ctrl;
};
typedef struct Data Data;
typedef struct Data * pData;


void npInitData (int argc, char* argv[], void* data);		// inits default

void npCloseData();

void* npDataGetDataRef();

#endif

